import { BasePlugin } from '@midwayjs/fcli-command-core';
import { MidwayHooksFunctionStructure } from '@midwayjs/next-hooks-compiler';
import { EventStructureType } from '@midwayjs/serverless-spec-builder';
import type { SpecStructureWithGateway } from '@midwayjs/hooks-shared';
export declare class MidwayHooksPlugin extends BasePlugin {
    spec: SpecStructureWithGateway;
    get gateway(): string;
    get root(): any;
    get isSkipTsBuild(): any;
    private static init;
    hooks: {
        'before:invoke:compile': () => Promise<void>;
        'after:invoke:emit': () => Promise<void>;
        'before:package:compile': () => Promise<void>;
        'after:package:emit': () => Promise<void>;
    };
    beforeCompile(): void;
    afterCompile(): Promise<void>;
    protected get argsPath(): any;
    protected createEventsByGateway(func: MidwayHooksFunctionStructure): EventStructureType[];
}
